[build-system]
requires = ["flit_core >=3.2,<4"]
build-backend = "flit_core.buildapi"

[tool.flit.module]
name = "autodoc2"

[project]
name = "sphinx-autodoc2"
dynamic = ["version", "description"]
authors = [{name = "Chris Sewell", email = "chrisj_sewell@hotmail.com"}]
license = {file = "LICENSE"}
classifiers = [
    "License :: OSI Approved :: MIT License",
    "Programming Language :: Python :: 3",
    "Framework :: Sphinx :: Extension",
]
keywords = ["sphinx", "autodoc", "extension", "documentation"]
urls = {Home = "https://github.com/chrisjsewell/sphinx-autodoc2"}
requires-python = ">=3.8"
dependencies = [
    "astroid>=2.7,<4",
    "tomli; python_version<'3.11'",
    "typing-extensions"
]

[project.optional-dependencies]
cli = ["typer[all]"]
# we don't put a hard dependency on sphinx,
# because anyway the core can be run without it
sphinx = ["sphinx>=4.0.0"]
testing = [
    "pytest",
    "pytest-regressions",
    "pytest-cov",
    "sphinx>=4.0.0,<7",
]
docs = [
    "sphinx>=4.0.0",
    "furo",
    "myst-parser"
]

[project.scripts]
autodoc2 = "autodoc2.cli:app_main"

[tool.ruff]
extend-select = ["B0", "C4", "I", "ICN", "ISC", "N", "RUF", "SIM", "T20", "UP"]

[tool.ruff.per-file-ignores]
# ignore: Do not perform function call `typer.Option` in argument defaults
"src/autodoc2/cli.py" = ["B008"]
"tests/test_analyse_module.py" = ["E501"]

[tool.ruff.lint.isort]
force-sort-within-sections = true

[tool.mypy]
show_error_codes = true
strict = true
exclude = ['^tests/.*']

[[tool.mypy.overrides]]
module = [
    "astroid.*",  # https://github.com/PyCQA/astroid/issues/1287
    "docutils.*",
    "tomllib.*",
    "tomli.*",
]
ignore_missing_imports = true

[[tool.mypy.overrides]]
module = ["autodoc2.sphinx.autodoc"]
# the try/except for tomllib/tomli causes different behaviour
# on different python versions
warn_unused_ignores = false

[tool.pytest.ini_options]
testpaths = [
    "tests",
]

[tool.tox]
legacy_tox_ini = """
[tox]
envlist = py38

[testenv]
usedevelop = true

[testenv:py{38,39,310,311}]
extras =
    testing
commands = pytest {posargs}

[testenv:cli-py{38,39,310,311}]
extras = cli
commands = autodoc2 {posargs}

[testenv:docs]
extras = docs
passenv =
    TERM
allowlist_externals = echo
commands = sphinx-build {posargs} -nW --keep-going -b html -d docs/_build/doctrees docs docs/_build/html
commands_post = echo "Documentation available at: docs/_build/html/index.html"
"""
